import Ember from 'ember';

const { 
  computed,
  getWithDefault,
  get: get,
  set: set
} = Em

export default Ember.Component.extend({
  classNames: ['en-multi-select-selection'],
  classNameBindings: ['setBackgroundColor:is-unique-color'],
  attributeBindings: ['style:style'],

  style: computed('selection.backgroundColor', 'setBackgroundColor', function () {
    let setBg = this.get('setBackgroundColor')
    if (!setBg) return Em.String.htmlSafe()

    let bgColor = getWithDefault(this, 'selection.backgroundColor', "#ADADAD")
    return Em.String.htmlSafe(`background-color: ${bgColor}; color: white`)
  }),

  label: computed('labelPath', function () {
    const path = getWithDefault(this, 'labelPath', 'label')
    const selection = get(this, 'selection')
    return get(selection, path)
  }),

  actions: {
    removeSelection () {
      this.sendAction('remove', this.get('selection'))
    },
  }
});
